package org.xbib.elx.http.action.get;

import org.elasticsearch.action.GenericAction;
import org.elasticsearch.action.get.GetAction;
import org.elasticsearch.action.get.GetRequest;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.common.CheckedFunction;
import org.elasticsearch.common.xcontent.XContentParser;
import org.xbib.elx.http.HttpAction;
import org.xbib.netty.http.client.RequestBuilder;

import java.io.IOException;

public class HttpExistsAction extends HttpAction<GetRequest, GetResponse> {

    @Override
    public GenericAction<GetRequest, GetResponse> getActionInstance() {
        return GetAction.INSTANCE;
    }

    @Override
    protected RequestBuilder createHttpRequest(String url, GetRequest request) {
        return newHeadRequest(url, "/" + request.index() + "/" + request.type() + "/" + request.id());
    }

    @Override
    protected CheckedFunction<XContentParser, GetResponse, IOException> entityParser() {
        return GetResponse::fromXContent;
    }

    @Override
    protected GetResponse emptyResponse() {
        return new GetResponse();
    }
}
